unit Unit9;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, DB,
  ADODB, Controls, IWVCLBaseControl, IWBaseControl,
  IWBaseHTMLControl, IWControl, IWCompButton, IWCompLabel, IWCompEdit,
  IWDBStdCtrls, Forms, IWVCLBaseContainer, IWContainer, IWHTMLContainer,
  IWHTML40Container, IWRegion, IWGAuthClient, IWBaseComponent,
  IWBaseHTMLComponent, IWBaseHTML40Component, IWTMSAuthBase,
  IWWindowsLiveAuthClient, IWExtCtrls;

type
  TIWForm9 = class(TIWAppForm)
    DataSource1: TDataSource;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    btLogin: TIWButton;
    btLogout: TIWButton;
    IWLabel5: TIWLabel;
    IWImageFile1: TIWImageFile;
    TIWWindowsLiveAuthClient1: TTIWWindowsLiveAuthClient;
    edID: TIWEdit;
    IWLabel7: TIWLabel;
    IWLabel9: TIWLabel;
    edSecret: TIWEdit;
    btSave: TIWButton;
    lbEmail: TIWLabel;
    lbBirthday: TIWLabel;
    lbGender: TIWLabel;
    IWLabel15: TIWLabel;
    IWLabel13: TIWLabel;
    IWLabel12: TIWLabel;
    IWLabel11: TIWLabel;
    IWLabel14: TIWLabel;
    IWDBEdit3: TIWDBEdit;
    IWLabel4: TIWLabel;
    IWLabel3: TIWLabel;
    IWDBEdit2: TIWDBEdit;
    IWDBEdit1: TIWDBEdit;
    IWLabel2: TIWLabel;
    IWLabel1: TIWLabel;
    IWLabel6: TIWLabel;
    IWLabel8: TIWLabel;
    lbLocalHost: TIWLabel;
    procedure IWAppFormCreate(Sender: TObject);
    procedure btLoginClick(Sender: TObject);
    procedure ToggleVisibility(Tag: integer; Visible: boolean);
    procedure CheckLogin(ID, Name, Error, Service: string; Result: TIWResult);
    procedure btLogoutClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure TIWWindowsLiveAuthClient1LoginFailed(Sender: TObject);
    procedure TIWWindowsLiveAuthClient1LoginOK(Sender: TObject);
    procedure IWAppFormRender(Sender: TObject);
  public
  end;

implementation

{$R *.dfm}

uses ServerController;

procedure TIWForm9.btLogoutClick(Sender: TObject);
begin
  btLogin.Visible := true;
  btLogout.Visible := false;
  ToggleVisibility(1, false);
  ToggleVisibility(2, false);
end;

procedure TIWForm9.btSaveClick(Sender: TObject);
begin
  DataSource1.DataSet.Active := true;
  DataSource1.DataSet.Edit;
  DataSource1.DataSet.Post;
  DataSource1.DataSet.Edit;
  WebApplication.ShowMessage('Data saved');
end;

procedure TIWForm9.ToggleVisibility(Tag: integer; Visible: boolean);
var
  I: integer;
begin
  for I := 0 to ControlCount - 1 do
  begin
    if Controls[I].Tag = Tag then
    begin
      TIWControl(Controls[I]).Visible := Visible;
    end;
  end;
end;

procedure TIWForm9.CheckLogin(ID, Name, Error, Service: string; Result: TIWResult);
var
  select: string;
begin
  if (Result = resOK) and
    (ID <> '') and (Name <> '') and (Service <> '') then
  begin
    IWLabel1.Text := 'Hello ' + Name + '!';

    select := 'SELECT * FROM [Users] WHERE [UserID] = "' + ID + '" and [Service] = "' + Service + '"';
    ADOQuery1.SQL.Text := select;
    DataSource1.DataSet.Active := true;

    //Create local account
    if DataSource1.DataSet.RecordCount = 0 then
    begin
      DataSource1.DataSet.Insert;
      DataSource1.DataSet.FieldValues['UserID'] := ID;
      DataSource1.DataSet.FieldValues['Service'] := Service;
      DataSource1.DataSet.Post;

      ADOQuery1.SQL.Text := select;
      DataSource1.DataSet.Active := true;
    end;

    IWDBEdit1.DataSource := DataSource1;
    IWDBEdit1.DataField := 'Data1';
    IWDBEdit2.DataSource := DataSource1;
    IWDBEdit2.DataField := 'Data2';
    IWDBEdit3.DataSource := DataSource1;
    IWDBEdit3.DataField := 'Data3';

    DataSource1.DataSet.Edit;

    ToggleVisibility(1, true);
    btLogin.Visible := false;
    btLogout.Visible := true;
    lbEmail.Text := TIWWindowsLiveAuthClient1.User.Email;
    lbBirthday.Text := TIWWindowsLiveAuthClient1.User.Birthday;
    lbGender.Text := TIWWindowsLiveAuthClient1.User.Gender;
  end
  else if (Result = resFailed) then
  begin
    ToggleVisibility(2, true);
    IWLabel8.Text := 'Login Failed';
    IWLabel6.Text := Error;
    TIWWindowsLiveAuthClient1.LoginResult := resNone;
  end;
end;


procedure TIWForm9.btLoginClick(Sender: TObject);
begin
  if edID.Text <> EmptyStr then
    TIWWindowsLiveAuthClient1.App.ID := edID.Text;
  if edSecret.Text <> EmptyStr then
    TIWWindowsLiveAuthClient1.App.Secret := edSecret.Text;

  if (TIWWindowsLiveAuthClient1.App.ID <> EmptyStr)
    and (TIWWindowsLiveAuthClient1.App.ID <> EmptyStr) then
  begin
    ToggleVisibility(2, false);
    TIWWindowsLiveAuthClient1.Login(WebApplication);
  end
  else
    WebApplication.ShowMessage('Please fill in your App ID and App Secret.');
end;

procedure TIWForm9.IWAppFormCreate(Sender: TObject);
begin
  DataSource1.DataSet.Active := false;
  ADOConnection1.ConnectionString :=
    'Provider=Microsoft.Jet.OLEDB.4.0;Password="";Persist Security Info=True;Data Source= ' +
  WebApplication.ApplicationPath + './users.mdb';
  DataSource1.DataSet.Active := true;

  TIWWindowsLiveAuthClient1.ServerController := IWServerController.TIWAuthServerController1;
  TIWWindowsLiveAuthClient1.Scopes := [wlBirthDay, wlEmail];

  btLogin.Visible := true;
  btLogout.Visible := false;
  ToggleVisibility(1, false);
  ToggleVisibility(2, false)
end;

procedure TIWForm9.IWAppFormRender(Sender: TObject);
begin
  if (pos('127.0.0.1', WebApplication.ApplicationURL) > 0)
    and (TIWWindowsLiveAuthClient1.StandaloneRedirectURL = EmptyStr) then
    lbLocalHost.Visible := true
  else
    lbLocalHost.Visible := false;
end;

procedure TIWForm9.TIWWindowsLiveAuthClient1LoginFailed(Sender: TObject);
begin
  CheckLogin(TIWWindowsLiveAuthClient1.LoginID, TIWWindowsLiveAuthClient1.LoginUsername,
    TIWWindowsLiveAuthClient1.LoginError, 'WindowsLive', TIWWindowsLiveAuthClient1.LoginResult);
end;

procedure TIWForm9.TIWWindowsLiveAuthClient1LoginOK(Sender: TObject);
begin
  CheckLogin(TIWWindowsLiveAuthClient1.LoginID, TIWWindowsLiveAuthClient1.LoginUsername,
    TIWWindowsLiveAuthClient1.LoginError, 'WindowsLive', TIWWindowsLiveAuthClient1.LoginResult);
end;

initialization
  TIWForm9.SetAsMainForm;

end.
